-- LLib v0.1
llib = {}

-- GENERAL HELPER FUNCTIONS --

function llib.inRect( mx, my, x, y, w, h )
	return mx >= x and mx <= x + w and my >= y and my <= y + h
end

-- DRAW --

function llib.rect( x, y, w, h, c, m )
	love.graphics.setColor( c )
	love.graphics.rectangle( m or "fill", x, y, w, h )
end

function llib.text( t, x, y, c, ax, ay )
	
end

-- STRING --

function string.explode( str, pat, plain )
	local t = {}
	plain = plain or false
	while true do
		p1, p2 = string.find( str, pat, 1, plain )
		if not p1 then
			t[ #t + 1 ] = str
			return t
		end
		t[ #t + 1 ] = string.sub( str, 1, p1 - 1 )
		str = string.sub( str, p2 + 1 )
	end
end

function string.left( str, n )
	return string.sub( str, 1, n )
end

function string.right( str, n )
	return string.sub( str, -n )
end

-- TABLE --

function table.serialize( tab )
	local s = "{"
	for k, v in pairs( tab ) do
		if type( k ) == "string" then
			s = s .. k .. "="
		elseif type( k ) == "number" then
			s = s .. "[" .. k .. "]="
		else
			error( "Unsupported table index value of type " .. type( k ) .. "! (" .. tostring( k ) .. ": " .. tostring( v ) .. ")" )
		end
		
		if type( v ) == "string" then
			s = s .. "\"" .. v .. "\","
		elseif type( v ) == "number" then
			s = s .. v .. ","
		elseif type( v ) == "table" then
			s = s .. table.serialize( v ) .. ","
		else
			error( "Unsupported value of type " .. type( v ) .. "! (" .. tostring( k ) .. ": " .. tostring( v ) .. ")" )
		end
	end
	s = string.sub( s, 1, #s - 1 )
	return s .. "}"
end

function table.deserialize( s )
	err, tab = pcall( loadstring, "return " .. s )
	if not err then
		error( tab )
	else
		return tab()
	end
end

function table.print( tab, ind )
	ind = ind or 0
	for k, v in pairs( tab ) do
		if type( v ) == "table" then
			print( string.rep( "\t", ind ) .. tostring( k ) .. " = \"" .. tostring( v ) .. "\":" )
			table.print( v, ind + 1 )
		else
			print( string.rep( "\t", ind ) .. tostring( k ) .. ": " .. tostring( v ) )
		end
	end
end